nation(pologne).
nation(allemagne).
nation(france).
nation(angleterre).
nation(irlande).
nation(espagne).
nation(belgique).
nation(luxembourg).

frontiere(pologne,allemagne).
frontiere(allemagne,france).
frontiere(france,espagne).
frontiere(france,belgique).
frontiere(belgique,allemagne).
frontiere(irlande,angleterre).
frontiere(luxembourg,france).
frontiere(luxembourg,belgique).
frontiere(luxembourg,allemagne).
frontiere(N1,N2) :- frontiere(N2,N1).

couleur(rouge).
couleur(bleu).
couleur(vert).
couleur(noir).

coloris(N,C) :- nation(N), couleur(C), not autre_coloris(N,C).

autre_coloris(N,C) :- nation(N), couleur(C), coloris(N,C1), C != C1.


:- frontiere(N1,N2), coloris(N1,C1), coloris(N2,C2), C1=C2.
