socks(red).
socks(blue).
socks(black).
socks(green).

boy(jean).
boy(pierre).
boy(martin).

% 
wears(B,C) :- 
    boy(B), socks(C), 
    not wears_other(B, C),
    not worn_by_other(C, B).

% B wears socks of color other than C
wears_other(B,C) :-
    boy(B), socks(C),
    wears(B,C1), C != C1.


% socks C are worn by boy other than B
worn_by_other(C, B) :-
    socks(C), boy(B),
    wears(B1, C), B != B1.

